unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics, system.UITypes;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    Series5: TLineSeries;
    Series6: TLineSeries;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    LabeledEdit3: TLabeledEdit;
    CheckBox3: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    procedure chart1coment;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, System.VarCmplx, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}

type
  DArray = array of double;

var
  xt, yt : Darray;              // x,y f[^[ akimaԗp
  m, t    : array of mp_float;  // m,t  akimaԗp

  BM : array of mp_float;       // xk[Cz
  FA : array of mp_float;       // Kz
  PVG : array of mp_float;      // +V
  MVG : array of mp_float;      // +V

  zero, one, two, four : mp_float;
  three, pai, log_2pis2 : mp_float;

const
  KMmax = 250;                  // KM max   250
  Vmax  = 100;                  // v  max
  GL = 9;                       // OtvZ{_

//------------------------------------------------------------------------------
  NB = 120;                            // xk[C  z NB + 1

var
  NumeratorString : array[0..NB] of string;               // q
  DenominatorString  : array[0..NB] of string;            // 

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                         // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];
      b0 := b0 * m * (m -1);                       // m xk[CNo
      NumeratorString[k] := a[0].tostring;
      DenominatorString[k] := b0.tostring;
      inc(k);
    end;
  end;
end;

//------------------------------------------------------------------------------

// OK}{
procedure log_GammaMul(var x, ans : mp_float);
var
  v, w : mp_float;
  tmp, tmp0, s : mp_float;
  i : integer;
begin
  mpf_init2(v, w);
  mpf_init3(tmp, tmp0, s);

  mpf_set1(v);
  mpf_set_int(tmp, NB);
  while mpf_is_lt(x, tmp) do begin
    mpf_mul(v, x, v);
    mpf_add(x, one, x);
  end;
  mpf_mul(x, x, tmp);               // x^2
  mpf_div(one, tmp, w);             // w = 1 / x^2
  mpf_set0(s);
  for i := NB downto 1 do begin
    mpf_add(s, BM[i], tmp);         // tmp = s + B[i]
    mpf_mul(tmp, w, s);             // s = tmp * w
  end;
  mpf_add(s, BM[0], tmp);           // tmp = s + B[0]
  mpf_div(tmp, x, s);               // s = (s + B[0]) / x
  mpf_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpf_ln(v, tmp);                   // ln(v)
  mpf_sub(s, tmp, s);               // s := s - ln(v)
  mpf_sub(s, x, s);                 // s := s - x
  mpf_div(one, two, tmp);           // tmp = 1/2
  mpf_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpf_ln(x, tmp);                   // ln(x)
  mpf_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpf_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpf_clear2(v, w);
  mpf_clear3(tmp, tmp0, s);
end;

// {K}
// x̒l 0 ƕ̎́ɂȂ̂łĂ܂̂ŃG[ɂȂ܂B
// Pr͎̎̎gp܂B
procedure gammaMul(var x, ans: mp_float);
var
  tmp, tmp0, logG : mp_float;
begin
  mpf_init3(tmp, tmp0, logG);

  if mpf_is_lt(x, zero) then begin
    mpf_mul(pai, x, tmp);            // x*
    mpf_sin(tmp, tmp0);              // sin(x);
    mpf_sub(one, x, tmp);            // 1-x
    log_GammaMul(tmp, logG);         // loggamma(1-x);
    mpf_exp(logG, logG);             // exp(logG)
    mpf_div(pai, tmp0, tmp);         // /sin(x)
    mpf_div(tmp, logG, ans);         // ans = /(sin(x) * logG(1-x))
  end
  else begin
    log_GammaMul(x, logG);           // logG
    mpf_exp(logG, ans);              // exp(logG)
  end;

  mpf_clear3(tmp, tmp0, logG);
end;

//------------------------------------------------------------------------------

// K {
procedure factorialMul(n : integer; var ans: mp_float);
label
  EXT;
var
  i : integer;
  bi : mp_float;
begin
  mpf_init(bi);

  mpf_set1(ans);
  mpf_copy(two, bi);
  if n <= 1 then begin
    goto EXT;
  end;
  for i := 2 to n do  begin
    mpf_mul(ans, bi, ans);
    mpf_add(bi, one, bi);
  end;
EXT:
  mpf_clear(bi);
end;

//------------------------------- complex power --------------------------------
// mpc_pow  **.5 Ԃ܂
procedure mpc_powa(x, y : mp_complex; var ans : mp_complex);
var
  ay, ai, zero, harf, two : mp_float;
begin
  mpf_init5(ay, ai, zero, harf, two);

  mpf_set_int(two, 2);                  // 2
  mpc_pow(x, y, ans);                     // exp(y*ln(x))
  // x̋y̋0Ȃ
  if mpf_is0(x.im) and mpf_is0(y.im) then begin
    mpf_set0(zero);                       // 0
    mpf_inv(two, harf);                   // 1/2  0.5
    mpf_abs(y.re, ay);                    // y̎̐Βl
    mpf_frac(ay, ai);                     // y̎̐Βl̏
    mpf_sub(ai, harf, ai);                // y̎̐Βl̏0.5̍
    // [(y̎̏0.5)
    if mpf_is0(ai) then
      // x̎0Ɠ0傫Ȃ
      if mpf_is_ge(x.re, zero) then mpf_set0(ans.im)   // ̋0
                               // 0菬Ȃ
                               else mpf_set0(ans.re);  // ̎0
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then mpf_set0(ans.im);              // Ȃ瓚̋0
  end;
  // x̐y̋0Ȃ
  if mpf_is0(x.re) and mpf_is0(y.im) then begin
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then begin                          // Ȃ
      mpf_div(y.re, two, ay);                          // mF
      mpf_frac(ay, ai);                                // 
      if mpf_is0(ai) then mpf_set0(ans.im)             // Ȃ 0
                     else mpf_set0(ans.re)             // Ȃ0
    end;
  end;
  mpf_abs(x.re, ay);
  mpf_abs(x.im, ai);
  // x̎Ƌ̐Βly[łȂ
  if mpf_is_eq(ay, ai) and mpf_is0(y.im) and not mpc_is0(y) then begin
    mpf_frac(y.re, ai);                                // 搔̏
    if mpf_is0(ai) then begin                          // Ȃ
      mpf_div(y.re, two, ay);                          // mF
      mpf_frac(ay, ai);                                // 
      if mpf_is0(ai) then begin
        mpf_add(two, two, two);                        // 4
        mpf_div(y.re, two, ay);                        // 4mF
        mpf_frac(ay, ai);                              // 
        if mpf_is0(ai) then mpf_set0(ans.im)           // Ȃ 0
                       else mpf_set0(ans.re);          // Ȃ 0
      end;
    end;
  end;

  mpf_clear5(ay, ai, zero, harf, two);
end;

//------------------------------------------------------------------------------
// X l f
// v 
// F False berv(z) true beri(z)
procedure berivz(var v : mp_float; var x, ri: mp_complex; F: boolean);
var
  k, j : integer;
  s, x24k, tmp, tmp0, tmp1 : mp_complex;
  xc, xs2: mp_complex;                      // ****
  kd, nd, vk : mp_float;
  khg, kf : mp_float;
  tmf, tmf0 : mp_float;
  sb : mp_complex;
  piv3s4, kpis2, pis2: mp_float;
  ar, ai, vn : mp_float;
begin
  mpc_init5(s, x24k, tmp, tmp0, tmp1);
  mpc_init2(xc, xs2);                       // ***
  mpf_init2(khg, kf);
  mpf_init3(kd, nd, vk);
  mpf_init2(tmf, tmf0);
  mpc_init(sb);
  mpf_init3(piv3s4, kpis2, pis2);
  mpf_init3(ar, ai, vn);

  mpf_div(pai, two, pis2);                  // /2
  mpf_div(pis2, two, tmf);                  // /4
  mpf_mul(tmf, three, tmf0);                // 3/4
  mpf_mul(tmf0, v, piv3s4);                 // 3v/4
  mpc_set0(s);                              // =0
  mpc_set0(sb);
  mpc_set1(x24k);                           // ***
  j := 0;

  mpc_div_mpf(x, two, xs2);                 // x / 2
  mpc_mul(xs2, xs2, xc);                    // (x^2)/ 4

  for k := 0 to KMmax do begin
    mpf_set1(nd);
    mpf_set_int(kf, k);                     // kf = k
    mpf_add(v, kf, tmf0);                   // k + v
    mpf_add(tmf0, one, vk);                 // vk = k + v + 1;
    if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
      mpf_int(vk, tmf);                     // int(vk);
      mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ vk = 0
    end;
    if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then begin  // vk̐̎͌vZȂ
      if mpf_is_ge(v, zero) then
        mpf_copy(PVG[k], tmf)
      else
        mpf_copy(MVG[k], tmf);
      mpf_mul(FA[k], tmf, khg);             // k!(n+k+1) vk0,̐̎}
//      mpc_set_mpf(kc, kf, zero);            // *** kc = k + 0i  f
//      mpc_powa(xc, kc, x24k);               // *** (i(x^2)/4)^k
      mpc_div_mpf(x24k, khg, tmp0);         // ((i(x^2)/4)^k)/(k!(v+k+1))
      mpf_mul(kf, pis2, kpis2);             // k/2
      mpf_add(piv3s4, kpis2, tmf);          // 3v/4 + k/2
      if not F then mpf_cos(tmf, tmf0)      // cos(3v/4 + k/2)
               else mpf_sin(tmf, tmf0);     // sin(3v/4 + k/2)
      mpc_mul_mpf(tmp0, tmf0, tmp0);
      mpc_add(s, tmp0, s);                  // 
      mpc_sub(s, sb, tmp0);
      if mpc_is0(tmp0) then begin
        inc(j);
        if j > 3 then break;
      end
      else j := 0;
      mpc_copy(s, sb);
    end;
    mpc_mul(x24k, xc, x24k);                // ***
  end;
  mpc_set_mpf(tmp, v, zero);                // v + 0i
  // x 0Ŏv̎powerZ[ł̏Zh~
  if mpc_is0(x) and mpf_is_lt(v, zero) then // V<0 x=0 ͖ɂȂ̂ŌvZȂ
  else begin
    mpc_powa(xs2, tmp, tmp0);               // (x/2)^v
    mpc_mul(s, tmp0, s);                    // (x/2)^v * 
  end;
  mpc_copy(s, ri);

  mpf_abs(x.re, ar);
  mpf_abs(x.im, ai);
  mpf_frac(v, vn);
  // x̎Ƌ̐Βl
  if mpf_is_eq(ar, ai) and mpf_is0(vn) then begin
    mpf_div(v, two, ar);
    mpf_frac(ar, ai);
    if mpf_is0(ai) then               // 
      if not F then mpf_set0(ri.im)
               else mpf_set0(ri.re);
  end;

  // x̋[
  if mpf_is0(x.im) then mpf_set0(ri.im);
  // x̎[
  if mpf_is0(x.re) and not mpf_is0(x.im) then begin
    mpf_frac(v, ar);
    if mpf_is0(ar) then begin             // 
      mpf_div(v, two, ai);
      mpf_frac(ai, ar);
      if mpf_is0(ar) then mpf_set0(ri.im)   // 
                     else mpf_set0(ri.re);  // 
    end
  end;

  mpc_clear5(s, x24k, tmp, tmp0, tmp1);
  mpc_clear2(xc, xs2);                      // ***
  mpf_clear2(khg, kf);
  mpf_clear3(kd, nd, vk);
  mpf_clear2(tmf, tmf0);
  mpc_clear(sb);
  mpf_clear3(piv3s4, kpis2, pis2);
  mpf_clear3(ar, ai, vn);
end;

// akima m,t e[u쐬
// x[] xf[^[z
// y[] yf[^[z
// m[] mWe[u
// t[] tWe[u
procedure akima_table;
var
  ii, n : integer;
  a, b, half, tmf, tmf0 : mp_float;
  ytm, xtm : array of mp_float;
  tmf1 : mp_float;
begin
  n := high(xt) + 1;
  setlength(ytm, n);
  setlength(xtm, n);
  for ii := 0 to n - 1 do begin
    mpf_init(ytm[ii]);
    mpf_init(xtm[ii]);
  end;

  mpf_init5(a, b, half, tmf, tmf0);
  mpf_init(tmf1);

  mpf_set_dbl(half, 1 / 2);
//  mpf_set_int(tow, 2);
//  mpf_set0(zero);

  for ii := 0 to n -1 do begin
    mpf_set_dbl(xtm[ii], xt[ii]);
    mpf_set_dbl(ytm[ii], yt[ii]);
  end;

  // shift data by + 2 in the array and compute the secants
  // also calculate extrapolated and end point secants
  // X΃[  y/x
  for ii := 0 to n - 2 do begin
    mpf_sub(ytm[ii + 1], ytm[ii], tmf);
    mpf_sub(xtm[ii + 1], xtm[ii], tmf0);
    mpf_div(tmf, tmf0, m[ii + 2]);
  end;
//  for ii := 0 to n - 2 do
//    m[ii + 2] := (yt[ii + 1] - yt[ii]) / (xt[ii + 1] - xt[ii]);
  // [_XΏ
  mpf_mul(two, m[2], tmf);
  mpf_sub(tmf, m[3], m[1]);
//  m[1] := 2 * m[2] - m[3];
  mpf_mul(two, m[1], tmf);
  mpf_sub(tmf, m[2], m[0]);
//  m[0] := 2 * m[1] - m[2];
  mpf_mul(two, m[n], tmf);
  mpf_sub(tmf, m[n - 1], m[n + 1]);
//  m[n + 1] := 2 * m[n] - m[n - 1];
  mpf_mul(two, m[n + 1], tmf);
  mpf_sub(tmf, m[n], m[n + 2]);
//  m[n + 2] := 2 * m[n + 1] - m[n];
  // e|CǧXΌWvZ
  for ii := 0 to n - 1 do begin
    mpf_sub(m[ii + 3],m[ii + 2],tmf0);
    mpf_abs(tmf0, a);
//    a := abs(m[ii + 3] - m[ii + 2]);
    mpf_sub(m[ii + 1], m[ii], tmf0);
    mpf_abs(tmf0, b);
//    b := abs(m[ii + 1] - m[ii]);
    mpf_add(a, b, tmf1);
    if mpf_is_ne(tmf1, zero) then begin
      mpf_mul(a, m[ii + 1], tmf);
      mpf_mul(b, m[ii + 2], tmf0);
      mpf_add(tmf, tmf0, tmf);
      mpf_div(tmf, tmf1, t[ii]);
    end
    else begin
      mpf_add(m[ii + 2], m[ii + 1], tmf);
      mpf_mul(half, tmf, t[ii]);
    end;
{
    if (a + b) <> 0 then begin
      t[ii] := (a * m[ii + 1] + b * m[ii + 2]) / (a + b);
    end
    else
      t[ii] := half * (m[ii + 2] + m[ii + 1]);
}
  end;

  for ii := 0 to n - 1 do begin
    mpf_clear(ytm[ii]);
    mpf_clear(xtm[ii]);
  end;

  mpf_clear5(a, b, half, tmf, tmf0);
  mpf_clear(tmf1);
end;

// akima ԒlvZ
// xx x̒l
// x[] xf[^[z
// y[] yf[^[z
// m[] mWe[u
// t[] tWe[u
// result Ԓly'
function akima_Interpolation(xx: double): double;
var
  iB, iM, iT: integer;
  a, b, tmf, tmf0 : mp_float;
  c, d, e, f, tmf1 : mp_float;
  three : mp_float;
begin
  mpf_init4(a, b, tmf, tmf0);
  mpf_init5(c, d, e, f, tmf1);
  mpf_init(three);

  mpf_set_int(three, 3);

  iB := low(xt);                       // x[] bottom zno
  iT := high(xt);                      // x[] topzNo
  // xxl̏㉺̔zx̔zԍT
  // XX<x[iB]̏ꍇԉ̋ XX>x[iT]̏ꍇԏ̋
  while (iT - iB) > 1 do begin
    iM := (iB + iT) div 2;            // middlezno
    if xt[iM] > xx then
      iT := iM
    else
      iB := iM;
  end;
  mpf_set_dbl(b, xt[iT] - xt[iB]);
//  b := xt[iT] - xt[iB];                 // Ԃx̕ω
  mpf_set_dbl(a, xx - xt[iB]);
//  a := xx - xt[iB];                     // x[iB]x̒l
  // 3akima spline vZ
  mpf_set_dbl(c, yt[iB]);               // c = yt[ib]
  mpf_mul(t[iB], a, d);                 // d = t[ib] * a
  mpf_mul(three, m[iB + 2], tmf);       // 3 * m[iB + 2]
  mpf_mul(two, t[ib], tmf0);            // 2 * t[iB]
  mpf_sub(tmf, tmf0, tmf1);             // 3 * m[iB + 2] - 2 * t[iB]
  mpf_sub(tmf1, t[iB + 1], tmf);        // 3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]
  mpf_mul(tmf, a, tmf);                 // (3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]) * a
  mpf_mul(tmf, a, tmf);                 // (3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]) * a * a
  mpf_div(tmf, b, e);                   // (3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]) * a * a / b
  mpf_add(t[iB], t[iB + 1], tmf);       // t[iB] + t[iB + 1]
  mpf_mul(two, m[iB + 2], tmf0);        // 2 * m[iB + 2]
  mpf_sub(tmf, tmf0, tmf);              // t[iB] + t[iB + 1] - 2 * m[iB + 2]
  mpf_mul(tmf, a, tmf);                 // (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a
  mpf_mul(tmf, a, tmf);                 // (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a * a
  mpf_mul(tmf, a, tmf);                 // (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a * a * a
  mpf_mul(b, b, tmf0);                  // b * b
  mpf_div(tmf, tmf0, f);                // (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a * a * a / (b * b)
  mpf_add(c, d, tmf);                   // c + d
  mpf_add(tmf, e, tmf);                 // c + d + e
  mpf_add(tmf, f, tmf);                 // c + d + e + f

  result := mpf_todouble(tmf);
{
  result :=   yt[iB]
            + t[iB] * a
            + (3 * m[iB + 2] - 2 * t[iB] - t[iB + 1]) * a * a / b
            + (t[iB] + t[iB + 1] - 2 * m[iB + 2]) * a * a * a / (b * b);
}

  mpf_clear4(a, b, tmf, tmf0);
  mpf_clear5(c, d, e, f, tmf1);
  mpf_clear(three);
end;

procedure TForm1.chart1coment;
begin
  with Chart1.BackImage.Bitmap.Canvas do begin
    Font.Size := 8;
    Font.Style := [];
    Font.Color := clred;
    TextOut(chart1.Width - 30, 1,'');
    Font.Color := clblue;
    TextOut(chart1.Width - 30, 13,'');
    Pen.Width := 1;
    Pen.Color := clred;
    MoveTo(chart1.Width - 50, 6);
    LineTo(chart1.Width - 32, 6);
    Pen.Color := clblue;
    MoveTo(chart1.Width - 50, 18);
    LineTo(chart1.Width - 32, 18);
  end;
end;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
// ta[]OtpvZ_
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  x0m = 1e-50;        // [ߖTl infinty ̕ݒvZl
  ta : array[0..GL - 1] of double = (0.08, 0.14, 0.23, 0.46, 0.86, 1.5, 2.5, 3.2, 4);
  YPM = 1E304;        // Double ZI[o[t[΍ őll
  YMM = - YPM;
  zeromg = '1E-90';   // vZʕ\菬l0ɂ܂ Z1/2
var
  ch, i, xi: integer;
  berx, beix: double;
  berxe, beixe: double;
  xin, vin, xv, rk, ik: double;
  xmin, xmax, dx, dxf : double;
  ymin, ymax: double;
  berl : Darray;
  beil : Darray;
  beru : Darray;
  beiu : Darray;
  xl   : Darray;
  xu   : Darray;
  xm, vm, xvm, ixm: mp_float;
  nd, tmf : mp_float;
  ri : mp_complex;
  GCF : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
  mm, ss, ms : integer;
  xc, xcb : mp_complex;
  GU, GS : integer;       // xv = 0 Ȃꍇ _
  k : integer;
  vk, avm, tmf0, zz : mp_float;
  ix : double;
  istr : string;
  F : boolean;
  // double to mpc  OtvZp
  procedure xvtoXc(xv, ia : double; var xc : mp_complex);
  begin
    mpf_set_dbl(xvm, xv);
    mpf_set_dbl(tmf, ia);
    mpc_set_mpf(xc, xvm, tmf);
  end;

  function maxmin(x : double): double;
  begin
    result := x;
    if x > YPM then result := YPM;
    if x < YMM then result := YMM;
  end;

begin
  memo1.Clear;
  val(labelededit1.Text, vin, ch);
  if ch <> 0 then begin
    application.MessageBox('v̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if abs(vin) > Vmax then begin
    application.MessageBox('v̒lvZ͈͊OłB','', 0);
    exit;
  end;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if abs(xin) > 100 then begin
    application.MessageBox('x100zƏɂČ덷傫Ȃ܂B','', 0);
  end;
  val(labelededit3.Text, ix, ch);
  if ch <> 0 then begin
    application.MessageBox('i ̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if abs(ix) > 100 then begin
    application.MessageBox('i100zƏɂČ덷傫Ȃ܂B','', 0);
  end;

  mpf_init4(xm, vm, xvm, ixm);
  mpf_init3(nd, tmf, zz);
  mpf_init3(vk, avm, tmf0);
  mpc_init3(ri, xc, xcb);

  F := False;
  if Checkbox3.Checked then F := true;

  mpf_set0(zero);
  mpf_set0(ixm);

  mpf_read_decimal(vm, PAnsiChar(ansistring(labelededit1.Text + #00)));
  mpf_read_decimal(xm, PAnsiChar(ansistring(labelededit2.Text + #00)));
  mpf_read_decimal(ixm, PAnsiChar(ansistring(labelededit3.Text + #00)));

  mpf_int(vm, tmf);
  mpf_sub(vm, tmf, tmf0);
  if not mpf_is0(tmf0) then begin
    if mpf_is_lt(xm, zero) then begin
      istr := 'v̒lłȂꍇAx̎͐łȂ' + #13#10 +
              '܂vZ𒆒f܂';
      if MessageDlg(istr , mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then goto EXT;
    end;
    if mpf_is_gt(xm, zero) then begin
      mpf_div(ixm, xm, tmf);
      mpf_chs(one, tmf0);
      if mpf_is_gt(tmf, one) or mpf_is_le(tmf, tmf0) then begin
        istr := 'v̒lłȂꍇAx̎̒l' + #13#10 +
                'fʂ-45<Ձ45̏łȂ' + #13#10 +
                '܂vZ𒆒f܂';
        if MessageDlg(istr , mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then goto EXT;
      end;
    end;
  end;

  mpf_read_decimal(zz, PAnsiChar(ansistring(zeromg + #00)));

  mpc_set_mpf(xcb, xm, ixm);                   // xcb vZp x̕f

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  series5.Clear;
  series6.Clear;
  with Chart1.BackImage.Bitmap.Canvas do begin
    Brush.Color := clWhite;
    Brush.Style := bsSolid;
    FillRect(rect(0, 0, chart1.Width, chart1.Height));
    Brush.Style := bsClear;
  end;

  if ix >= 0 then istr := ' +' + floatTostr(ix) + 'i'
             else istr := ' ' + floatTostr(ix) + 'i';
  memo1.Lines.Append('n = ' + floatTostr(vin) + '@@x = ' + floatTostr(xin) + istr);

  application.ProcessMessages;

  rk := 0;
  ik := 0;

  mpf_abs(vm, avm);
  for k := 0 to KMmax do begin
    mpf_set_int(tmf, k);                    // k
    mpf_add(tmf, avm, tmf0);                // v + k
    mpf_add(tmf0, one, vk);                 // vk= v + k + 1
    gammaMul(vk, PVG[k]);                   // (n+k+1)
  end;
  mpf_chs(avm, avm);                        // -v
  for k := 0 to KMmax do begin
    mpf_set1(nd);
    mpf_set_int(tmf, k);                    // k
    mpf_add(tmf, avm, tmf0);                // -v + k
    mpf_add(tmf0, one, vk);                 // vk= -v + k + 1
    if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
      mpf_int(vk, tmf);                     // int(vk);
      mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ nd = 0
    end;
    if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then // vk̐̎͌vZȂ
      gammaMul(vk, MVG[k])                  // (n+k+1)
    else
      mpf_set0(MVG[k]);                     // (n+k+1) = 0
  end;

  // [ߖŤvZݒ
  // x=0 @v < 0 @v = 񐮐  ̏ꍇ  }
 if mpc_is0(xcb) and mpf_is_lt(vm, zero) and mpf_is_ne(nd, zero) then begin
    xvtoxc(x0m, ix, xc);                    // x double to mpc
    berivz(vm, xc, ri, F);                        // [ߕӂ̃vXxvZ
    if mpf_is_gt(ri.re, zero) then rk := infinity;      // x=0̖}ݒ
    if mpf_is_lt(ri.re, zero) then rk := -infinity;
    if mpf_is_gt(ri.im, zero) then ik := infinity;
    if mpf_is_lt(ri.im, zero) then ik := -infinity;
  end;
  mpf_int(vm, tmf);                        // int(vm)
  mpf_sub(vm, tmf, nd);                    // nd = vm - int(v)

  StopWatch := TStopwatch.StartNew;

  // \ľvZ
  if not mpc_is0(xcb) then
    berivz(vm, xcb, ri, F);                        // xcb f
  // x=0 @v < 0 @v = 񐮐  ̏ꍇ  }
  if mpc_is0(xcb) then begin
    if mpf_is_lt(vm, zero) and mpf_is_ne(nd, zero) then begin
      berxe := rk;
      beixe := ik;
    end
    else begin
      berxe := 0;
      beixe := 0;
    end;
    if mpf_is0(vm) and not F then berxe := 1;
    if checkbox3.Checked = false then
      memo1.Lines.Append('berv(x) =  ' + floatTostr(berxe))       // l\
    else
      memo1.Lines.Append('beiv(x) =  ' + floatTostr(berxe));      // l\
  end
  else begin
    if checkbox3.Checked = false then
      memo1.Lines.Append( string('berv(x) = ' + mpf_decimal(ri.re, 50)))
    else
      memo1.Lines.Append( string('beiv(x) = ' + mpf_decimal(ri.re, 50)));
    if not mpf_is0(ixm) then begin
      if mpf_is_ge(ri.im, zero) then
        memo1.Lines.Append( string('        +' + mpf_decimal(ri.im, 50) + 'i'))
      else
        memo1.Lines.Append( string('         ' + mpf_decimal(ri.im, 50) + 'i'));
      beixe := mpf_todouble(ri.im);
    end
    else
      beixe := 0;
    berxe := mpf_todouble(ri.re);
  end;

  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;

  ms := ElapsedMillseconds * (GL + 1) * 2 + 1000;
  mm := ms div 60000;
  ss := (ms mod 60000) div 1000;
  memo1.Lines.Append('Ot\ɖ' + inttostr(mm) + '' + inttostr(ss) + 'bKvłB');

  if checkbox2.Checked = true then begin          // OtI
    with Chart1.BackImage.Bitmap.Canvas do begin
      Font.Style := [fsBold];
      Font.size := 8;
      TextOut(170, 115,'Ot');
    end;
    goto EXT;
  end;

  // őlŏľƃOtf[^[쐬
  xi := round(xin);
  xmin := xi - 4;
  GCF := 0;
  if (Xin >= -2) and (xin <=  2) then GCF := 1;
  if (xin >= -3) and (xin <= -2) then GCF := 2;
  if (xin >=  2) and (xin <=  3) then GCF := 3;
  if (xin >= -4) and (xin <= -3) then GCF := 4;
  if (xin >=  3) and (xin <=  4) then Gcf := 5;
  case GCF of
    0:  xmin := xi - 4;
    1:  xmin := -4;
    2:  xmin := -5;
    3:  xmin := -3;
    4:  xmin := -6;
    5:  xmin := -2;
  end;
  if mpf_is_ge(xm, ixm) and mpf_is_ge(ixm, zero) then begin
    mpf_int(vm, tmf);
    mpf_sub(vm, tmf, tmf0);
    if not mpf_is0(tmf0) then begin
      xmin := mpf_todouble(ixm);
      GCF := 0;
    end;
  end;
  xmax := xmin + 8;
  case GCF of
    0 : begin
          setlength(berl, GL + GL);
          setlength(beil, GL + GL);
          setlength(xt, GL + GL); setlength(yt, GL + GL);
          setlength(xl, GL + GL);
        end;
    1, 2, 3, 4, 5:
        begin
          setlength(berl, GL); setlength(beru, GL);
          setlength(beil, GL); setlength(beiu, GL);
          setlength(xt, GL); setlength(yt, GL);
          setlength(xl, GL); setlength(xu, GL);
        end;
  end;

  dxf := 0.1;
  dx  := 0.1;
  GU := 40;
  GS := 40;
  case GCF of
    0 :
      begin
        dx := (xmax - xmin) / (Gl + GL - 1);
        for i := 0 to GL + GL - 1 do xl[i] := dx * i + xmin;
        xl[0] := xl[0] + dxf;
        xl[GL + GL - 1] := xl[GL + GL - 1] - dxf;
        GS := 80;
      end;
    else
      begin
        for i := 0 to GL - 1 do begin
          xu[i] := ta[i];
          xl[GL - i - 1] := -ta[i];
        end;
      end;
  end;
  case GCF of
    2 : begin dx  := 5 / 4; dxf := 3 / 4; GS := 50; GU := 30; end;
    3 : begin dx  := 3 / 4; dxf := 5 / 4; GS := 30; GU := 50; end;
    4 : begin dx  := 6 / 4; dxf := 2 / 4; GS := 60; GU := 20; end;
    5 : begin dx  := 2 / 4; dxf := 6 / 4; GS := 20; GU := 60; end;
  end;
  if GCF >= 2 then begin
    for i := 0 to Gl - 1 do xl[i] := xl[i] * dx;
    for i := 0 to Gl - 1 do xu[i] := xu[i] * dxf;
  end;

  // Otpf[^[쐬
  ymin := 0;
  ymax := 0;
  case GCF of
    0 : begin
      for i := 0 to GL + GL - 1 do begin
        xv := xl[i];
        xvtoxc(xv, ix, xc);
        berivz(vm, xc, ri, F);
        berl[i] := maxmin(mpf_todouble(ri.re));
        beil[i] := maxmin(mpf_todouble(ri.im));
        if berl[i] > ymax then ymax := berl[i];
        if beil[i] > ymax then ymax := beil[i];
        if berl[i] < ymin then ymin := berl[i];
        if beil[i] < ymin then ymin := beil[i];
      end;
    end;
    1, 2, 3, 4, 5:
      for i := 0 to GL - 1 do begin
        xv := xl[i];
        xvtoxc(xv, ix, xc);
        berivz(vm, xc, ri, F);
        berl[i] := maxmin(mpf_todouble(ri.re));
        beil[i] := maxmin(mpf_todouble(ri.im));
        if berl[i] > ymax then ymax := berl[i];
        if beil[i] > ymax then ymax := beil[i];
        if berl[i] < ymin then ymin := berl[i];
        if beil[i] < ymin then ymin := beil[i];
        xv := xu[i];
        xvtoxc(xv, ix, xc);
        berivz(vm, xc, ri, F);
        beru[i] := maxmin(mpf_todouble(ri.re));
        beiu[i] := maxmin(mpf_todouble(ri.im));
        if beru[i] > ymax then ymax := beru[i];
        if beiu[i] > ymax then ymax := beiu[i];
        if beru[i] < ymin then ymin := beru[i];
        if beiu[i] < ymin then ymin := beiu[i];
      end;
  end;

  // wl̒l
  if berxe > ymax then berxe := ymax;
  if berxe < ymin then berxe := ymin;
  if beixe > ymax then beixe := ymax;
  if beixe < ymin then beixe := ymin;

  series3.AddXY(xin, berxe);
  series4.AddXY(xin, beixe);

  if checkbox1.Checked = true then
    case GCF of
      0:
        begin
          for  i := 0 to GL + GL - 1 do series1.AddXY(xl[i], berl[i]);
          for  i := 0 to GL + GL - 1 do series2.AddXY(xl[i], beil[i]);
        end;
      1, 2, 3, 4, 5 :
        begin
          for i := 0 to GL - 1 do series1.AddXY(xl[i], berl[i]);
          for i := 0 to GL - 1 do series2.AddXY(xl[i], beil[i]);
          for i := 0 to GL - 1 do series5.AddXY(xu[i], beru[i]);
          for i := 0 to GL - 1 do series6.AddXY(xu[i], beiu[i]);
        end;
    end;

  if checkbox1.Checked = false then
  // OtvZ
    case GCF of
      0:
        begin
          for  i := 0 to GL + GL - 1 do begin
            xt[i] := xl[i];
            yt[i] := berl[i];
          end;
          akima_table;
          dx := (xt[GL + GL - 1] - xt[0]) / GS;
          for i := 0 to GS do begin
            xv := dx * i + xt[0];
            berx := maxmin(akima_Interpolation(xv));
            series1.AddXY(xv, berx);
          end;
          for  i := 0 to GL + GL - 1 do yt[i] := beil[i];
          akima_table;
          for i := 0 to GS do begin
            xv := dx * i + xt[0];
            beix := maxmin(akima_Interpolation(xv));
            series2.AddXY(xv, beix);
          end;
        end;
      1, 2, 3, 4, 5 :
        begin
          for  i := 0 to GL- 1 do begin
            xt[i] := xl[i];
            yt[i] := berl[i];
          end;
          akima_table;
          dx := xt[0] / GS;
          for i := GS downto 1 do begin
            xv := dx * i;
            berx := maxmin(akima_Interpolation(xv));
            series1.AddXY(xv, berx);
          end;
          for  i := 0 to GL- 1 do yt[i] := beil[i];
          akima_table;
          for i := GS downto 1 do begin
            xv := dx * i;
            beix := maxmin(akima_Interpolation(xv));
            series2.AddXY(xv, beix);
          end;

          if mpf_is0(xm) then begin
//            series1.AddXY(0, herxe);
//            series2.AddXY(0, heixe);
            series5.AddXY(0, berxe);
            series6.AddXY(0, beixe);
          end;

          for  i := 0 to GL- 1 do begin
            xt[i] := xu[i];
            yt[i] := beru[i];
          end;
          akima_table;
          dx := xt[GL - 1] / GU;
          for i := 1 to GU do begin
            xv := dx * i;
            berx := maxmin(akima_Interpolation(xv));
            series5.AddXY(xv, berx);
          end;
          for  i := 0 to GL- 1 do yt[i] := beiu[i];
          akima_table;
          for i := 1 to GU do begin
            xv := dx * i;
            beix := maxmin(akima_Interpolation(xv));
            series6.AddXY(xv, beix);
          end;
        end;
    end;
  application.ProcessMessages;
  chart1coment;
EXT:
  mpf_clear4(xm, vm, xvm, ixm);
  mpf_clear3(nd, tmf, zz);
  mpc_clear3(ri, xc, xcb);
  mpf_clear3(vk, avm, tmf0);
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
  N, D, tmp : mp_float;
  bt : Tbitmap;
begin
  mpf_set_default_decprec(180);         // L180 50̐xɕKvłB
  setlength(BM, NB + 1);                // xk[Cz
  setlength(FA, KMmax + 1);      // K1z
  setlength(PVG, KMmax + 1);     // +v
  setlength(MVG, KMmax + 1);     // -v
  setlength(t, GL + GL);                // akima ԒlvZ z t
  setlength(m, GL + GL + 3);            // akima ԒlvZ z m


  for i := 0 to NB do mpf_init(BM[i]);
  for i := 0 to KMmax do mpf_init(FA[i]);
  for i := 0 to KMmax do mpf_init(PVG[i]);
  for i := 0 to KMmax do mpf_init(MVG[i]);

  for i := 0 to GL + GL - 1 do mpf_init(t[i]);
  for i := 0 to GL + GL + 2 do mpf_init(m[i]);

  mpf_init3(N, D, tmp);
  mpf_init4(zero, one, two, four);
  mpf_init3(three, pai, log_2pis2);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);

  mpf_mul(pai, two, tmp);          // 2
  mpf_ln(tmp, tmp);                // ln(2)
  mpf_div(tmp, two, log_2pis2);    // ln(2)/2


  Bernoulli_number_BigInteger;              //  xk[C쐬

  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);
  end;

  for i := 0 to KMmax do begin
    factorialMul(i, N);
    mpf_copy(N, FA[i]);
  end;

  memo1.Clear;

  bt := Tbitmap.Create;
  bt.Width := Chart1.Width;
  bt.Height := Chart1.Height;
  Chart1.BackImage.Bitmap := bt;
  bt.Free;

  mpf_clear3(N, D, tmp);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  for i := 0 to KMmax do mpf_clear(FA[i]);
  for i := 0 to KMmax do mpf_clear(PVG[i]);
  for i := 0 to KMmax do mpf_clear(MVG[i]);
  for i := 0 to GL + GL - 1 do mpf_clear(t[i]);
  for i := 0 to GL + GL + 2 do mpf_clear(m[i]);
  mpf_clear4(zero, one, two, four);
  mpf_clear3(three, pai, log_2pis2);
end;

end.
